DATA         SEGMENT  AT  00H
             ORG 1AH*4
TV_INTER     LABEL WORD
             ORG 23H*4
VIDEO_INTER  LABEL WORD
             ORG 03C2H
TV_FLAG      LABEL BYTE
;
; 3.3 video display data
;
             ORG 7C0H
VIDEO_MOD        DB ?
CRT_COLUMN_COUNT DW ?
PAGE_LEN         DW ?
CRT_REGEN_START  DW ?
CURSOR_POSITION  DW 8 DUP(?)
CURSOR_TYPE      DW ?
CURRENT_PAGE     DB ?
CRT_ADDR         DW ?
SET_MODE         DB ?
PALLETTE         DB ?

CRT_COLOR        EQU 03D4H
CRT_BW           EQU 03B4H
CRT_CONTROL      EQU 03D8H
CRT_CONRTOL_BW   EQU 03B8H
CRT_STATUS       EQU 03DAH
CRT_STATUS_BW    EQU 03BAH
 
; USED BY MPF-I/88
;
VIDEO_MODE_FLAG  DW ?
VIDEO_EQUP       DB ?
MODE_FLAG        DB ?
STATUS_OF_FLAG   DB ?
CARD_6845_PORT   DB ?
STATUS_OF_EQUP   DW ?
EXTEN_PTR        DD ?
FLAG             DB ?
EXIST            DB ?
NATIVE_POS       DB ?

DATA ENDS

CODE      SEGMENT PARA PUBLIC 'CODE'
          ASSUME CS:CODE,DS:DATA
INIT PROC FAR
command:
    db  'MT1'
    push  ds
    push  es
    push  di
    call  CHANGE_DS
    mov bx, 0
    xor al, al

find_again:
    cmp byte ptr es:[di], 5Ah ; 'Z'
    jz  short fill_command_1
    scasb
    jz  short fill_command
    inc bx
    cmp bx, 5
    jnz short find_again
    pop di
    jmp VIDEO_END
fill_command:
    dec di
fill_command_1:
    mov al, 5Ah ; 'Z'
    stosb
    shl bx, 1
    shl bx, 1
    pop di
    mov ax, OFFSET start ;169h
    mov es:[bx+di+5], ax
    push  cs
    pop word ptr es:[bx+di+7]
    mov [FLAG], 0
    mov [EXIST], 0
    mov ax, OFFSET CRT_DRV ;1F7h
    mov word ptr VIDEO_INTER, ax
    mov bx, cs
    mov word ptr VIDEO_INTER+2, bx
    mov word ptr TV_INTER, OFFSET TV_DRV ;15Ch
    mov bx, cs
    mov word ptr TV_INTER+2, bx
    mov ax, OFFSET GRAPHICS_CHAR ;0A16h
    mov word ptr EXTEN_PTR, ax
    mov ax, cs
    mov word ptr EXTEN_PTR+2, ax
    mov STATUS_OF_EQUP, 30h
    mov VIDEO_EQUP, 0B0h
    mov ax, 7
    int 23h  
    mov dx, 3B8h
    mov al, 1
    out dx, al
    push  ds
    mov ax, 0B000h
    mov es, ax
    mov ds, ax
    mov cx, 1000h
    call  TEST_RAM
    pop ds
    jz  short TEST0
    mov STATUS_OF_EQUP, 20h
    mov VIDEO_EQUP, 0B8h
    mov ax, 3
    int 23h 
    mov dx, 3D8h
    mov al, 0
    out dx, al
    push  ds
    mov ax, 0B800h
    mov es, ax
    mov ds, ax
    mov cx, 4000h
    call  TEST_RAM
    pop ds
    jz  short TEST0
    mov [EXIST], 0FFh
    jmp short VIDEO_END
    db  90h
TEST0:
    cld
    mov ax, STATUS_OF_EQUP
    cmp al, 30h ; '0'
    mov dx, 3BAh
    mov bx, 0B000h
    jz  short TEST1
    mov dx, 3DAh
    mov bx, 0B800h
TEST1:
    mov es, bx
    mov ax, 2BCh
    mov di, 0
    mov cx, 50h ; 'P'
    rep stosw
    mov ah, 8
TEST2:
    sub cx, cx
TEST3:
    in  al, dx
    and al, ah
    jnz short TEST4
    loop  TEST3
    jmp short TEST7
    db  90h
TEST4:
    sub cx, cx
TEST5:
    in  al, dx
    and al, ah
    jz  short TEST6
    loop  TEST5
    jmp short TEST7
    db  90h
TEST6:
    mov cl, 3
    shr ah, cl
    jnz short TEST2
    jmp short TEST8
    db  90h
TEST7:
    mov [EXIST], 0FFh
    jmp short VIDEO_END
    db  90h
TEST8:
    mov ax, 3
    cmp dx, 3DAh
    jz  short TEST9
    mov al, 7
TEST9:
    mov ah, 0
    int 23h
    mov ax, 0
    mov ds, ax
VIDEO_END:
    pop es
    pop ds
    retf

; ---------------------------------------------------------------------------
ERR0   proc near
    int 0Ch
    push  cs
    pop ds
    mov si, OFFSET ERRMSG2 ;2AAh
ERR1:
    int 0Dh
    retn
ERR0   endp

; ---------------------------------------------------------------------------
TEST_RAM  proc near
    cld
    mov bx, cx
    mov ax, 0FFFFh
    mov dx, 0AA55h
    sub di, di
    rep stosb
loc_133:
    dec di
    std
loc_135:
    mov si, di
    mov cx, bx

C1:
    lodsb
    xor al, ah
    jnz short C3
    cmp ah, 0
    jz  short C2
    mov al, dl
    stosb

C2:
    loop  C1
    cmp ah, 0
    jz  short C3
    mov ah, al
    xchg  dh, dl
    cld
    inc di
    jz  short loc_135
    dec di
    mov dx, 1
    jmp short loc_133
C3:
    retn
TEST_RAM  endp

; ---------------------------------------------------------------------------
TV_DRV PROC NEAR
    push  ax
    push  bx
    push  cx
    mov ah, 0Eh
    mov bl, 3
    int 23h 
    pop cx
    pop bx
    pop ax
    iret
TV_DRV ENDP

; ---------------------------------------------------------------------------
START:
    push  ds
    call  CHANGE_DS
    cmp FLAG, 0
    jnz short START2
    inc FLAG
    mov ax, OFFSET CRT_DRV ;1F7h
    mov word ptr VIDEO_INTER, ax
    mov bx, cs
    mov word ptr VIDEO_INTER+2, bx
    mov word ptr TV_INTER, OFFSET TV_DRV ;15Ch
    mov bx, cs
    mov word ptr TV_INTER+2, bx
    mov ax, OFFSET GRAPHICS_CHAR ;0A16h
    mov word ptr EXTEN_PTR, ax
    mov ax, cs
    mov word ptr EXTEN_PTR+2, ax
START2:
    cmp [EXIST], 0
    jz  short START4
    call  ERR0
    pop ds
    jmp short START_END
    db  90h
START4:
    pop ds
    inc si
    call  SKIP_SPACE
    cmp byte ptr [si], 0Dh
    jz  short START5
    cmp byte ptr [si], 30h ; '0'
    jb  short ERROR_1
    cmp byte ptr [si], 36h ; '6'
    ja  short ERROR_1
    mov al, [si]
    inc si
    call  SKIP_SPACE
    cmp byte ptr [si], 0Dh
    jnz short ERROR_1
    mov ah, 0
    sub al, 30h ; '0'
    int 23h
    cmp byte ptr TV_FLAG, 0FFh
    jz  short START_END
START5:
    xor byte ptr TV_FLAG, 0FFh
START_END:
    retf
; ---------------------------------------------------------------------------

ERROR_1:
    push  ds
    push  cs
    pop ds
    mov si, OFFSET SYNTAX_ERR ;1EFh
    int 0Dh
    pop ds
    retf

; ---------------------------------------------------------------------------
SKIP_SPACE  proc near
    cld
SKIP_1:
    cmp byte ptr [si], 20h ; ' '
    jnz short SKIP_END
    inc si
    jmp short SKIP_1
SKIP_END:
    retn
SKIP_SPACE  endp

; ---------------------------------------------------------------------------
SYNTAX_ERR:  DB 'Error 0','1'+80h
; ---------------------------------------------------------------------------

CRT_DRV PROC NEAR
    cmp ah, 0Fh
    jbe short LX1
    iret
LX1:
    call  SAVE_REGISTER
    mov di, ax
    mov si, OFFSET D_TABLE ;242h
    call  CHANGE_DS
    push  cx
    xor cl, cl
    mov ch, VIDEO_EQUP
    push  cx
    pop es
    mov cl, 7
    shr ax, cl
    and ax, 1FEh
    mov bp, ax
    mov ax, di
    pop cx
    cld
    jmp word ptr cs:[bp+si]
CRT_DRV ENDP

; ---------------------------------------------------------------------------
SAVE_REGISTER proc near
    sti
    push  bx
    push  cx
    push  dx
    push  di
    push  si
    push  bp
    push  ds
    push  es
    mov di, sp
    mov si, ss:[di+10h]
    push  si
    retn
SAVE_REGISTER endp

; ---------------------------------------------------------------------------
RECOVER_REGISTER proc near
    pop si
    mov di, sp
    mov ss:[di+10h], si
    pop es
    pop ds
    pop bp
    pop si
    pop di
    pop dx
    pop cx
    pop bx
    retn
RECOVER_REGISTER endp

; ---------------------------------------------------------------------------
D_TABLE:
    dw SELECT_VIDEO_MOD ;585h
    dw DEFINE_CURSOR_TYPE ;817h
    dw POSITION_CURRENT_CURSOR ;856h
    dw GET_CURSOR ;841h
    dw GET_LP_POSITION ;91Dh
    dw ACT_DISP_PAGE ;7EFh
    dw SCROLL_UP ;739h
    dw SCROLL_DOWN ;744h
    dw READ_ATCH_CUR ;87Bh
    dw WRITE_ATCH_CUR ;49Eh
    dw WRITE_CH_CUR ;4A8h
    dw SET_COLOR ;9CDh
    dw WRITE_DOT ;8A9h
    dw READ_DOT ;8A6h
    dw WRITE_TTY ;691h
    dw VIDEO_STATE ;9F8h
TABLE_VALUE:
    db  38h, 28h, 2Dh, 0Ah
    db  1Fh,   6, 19h, 1Ch
    db    2,   7,   6,   7
    db    0,   0,   0,   0
    db  71h, 50h, 5Ah, 0Ah
    db  1Fh,   6, 19h, 1Ch
    db    2,   7,   6,   7
    db    0,   0,   0,   0
    db  38h, 28h, 2Dh, 0Ah
    db  7Fh,   6, 64h, 70h
    db    2,   1,   6,   7
    db    0,   0,   0,   0
    db  61h, 50h, 52h, 0Fh
    db  19h,   6, 19h, 19h
    db    2, 0Dh, 0Bh, 0Ch
    db    0,   0,   0,   0
TB1 LABEL BYTE
    db  2Ch, 28h, 2Dh, 29h
    db  2Ah, 2Eh, 1Eh, 29h
ERRMSG2: DB 'CARD ERRO','R'+80h
; ---------------------------------------------------------------------------

GRAPHICS_UP_DOWN PROC NEAR
    mov bp, 0
    mov si, bp
    popf
    pushf
    jb  short GR1
    inc bp
    mov si, 0F0h ; ''
GR1:
    test  MODE_FLAG, 40h
    jnz short GR2
    add dl, dl
    add di, bp
GR2:
    add di, si
    mov bp, 50h ; 'P'
    popf
    jb  short GR3
    neg bp
GR3:
    mov ax, es
    mov ds, ax
    xor ch, ch
    pop ax
    xchg  bh, bl
    push  bx
    add al, al
    add al, al
    push  ax
    mov bx, bp
    imul  bl
    push  di
    pop si
    add si, ax
    pop ax
    add dh, dh
    add dh, dh
    test  al, 0FFh
    jz  short GR5
    sub dh, al
    xchg  al, dh
    jz  short GR5
GR4:
    stc
    call  WRITE_CLEAR_ROW
    add si, bp
    dec al
    jg  short GR4
GR5:
    pop ax
GR6:
    clc
    call  WRITE_CLEAR_ROW
    dec dh
    jg  short GR6
    jmp VIDEO_RETURN
GRAPHICS_UP_DOWN ENDP
; ---------------------------------------------------------------------------

GRAPHICS_WRITE PROC NEAR
    push  si
    mov ch, bl
    mov bx, ax
    cmp bl, 0
    jl  short GW0
    mov si, OFFSET GRAPHICS_CHAR ;0A16h
    mov bp, cs
    jmp short GW1
GW0:
    and bl, 7Fh
     ASSUME DS:DATA
    push  ax
    mov ax, DATA
    mov ds, ax
    pop ax
    lds si, EXTEN_PTR
GW1:
    xor ah, ah
    mov ax, CURSOR_POSITION
    call  POSITION
    mov cl, 3
    xor bh, bh
    shl bx, cl
    mov di, ax
    add si, bx
    test  MODE_FLAG, 40h
    mov ds, bp
    mov bp, 2000h
    mov bl, ch
    mov cx, 4
    mov dx, di
    jnz short HIGH_RESOLUTION_WRITE
MEDIUM_RESOLUTION_WRITE:
    mov ch, bl
    xor ax, ax
    shr bl, 1
    jnb short EMC1
    or  ax, 5555h
EMC1:
    shr bl, 1
    jnb short EMC2
    or  ax, 0AAAAh
EMC2:
    mov bx, ax
EMC3:
    call  MEDIUM_LOAD
    add di, bp
    inc si
    call  MEDIUM_LOAD
    sub di, bp
    dec si
    call  ADD_OFFSET
    dec cl
    jnz short EMC3
    pop cx
    dec cx
    ja  short GWR_LOOP1
    jmp VIDEO_RETURN
GWR_LOOP1:
    call  REC_DISI
    add di, 1
    call  SAV_DISI
    push  cx
    mov cl, 4
    jmp short EMC3
HIGH_RESOLUTION_WRITE:
GW2:
    mov ax, [si]
    cmp bl, 0
    jge short GW3
    xor al, es:[di]
    xor ah, es:[bp+di]
GW3:
    mov es:[di], al
    mov es:[bp+di], ah
    call  ADD_OFFSET
    loop  HIGH_RESOLUTION_WRITE
    pop cx
    dec cx
    ja  short GWR_LOOP
    jmp VIDEO_RETURN
GWR_LOOP:
    push  cx
    mov cx, 4
    call  REC_DISI
    call  SAV_DISI
    jmp short HIGH_RESOLUTION_WRITE
GRAPHICS_WRITE ENDP
; ---------------------------------------------------------------------------

REC_DISI PROC NEAR 
    sub si, 8
    mov di, dx
    retn
REC_DISI ENDP

; ---------------------------------------------------------------------------
ADD_OFFSET  proc near
    add si, 2
    add di, 50h ; 'P'
    retn
ADD_OFFSET  endp

; ---------------------------------------------------------------------------
SAV_DISI  proc near
    inc di
    mov dx, di
    retn
SAV_DISI  endp

; ---------------------------------------------------------------------------
MEDIUM_LOAD proc near
    push  bp
    push  bx
    mov al, [si]
    mov bx, 3
    xor bp, bp
EX1:
    test  al, 0FFh
    jz  short EX3
    shr al, 1
    jnb short EX2
    or  bp, bx
EX2:
    shl bx, 1
    shl bx, 1
    jmp short EX1
EX3:
    mov ax, bp
    pop bx
    pop bp
    and ax, bx
    xchg  ah, al
    cmp ch, 0
    jge short EX4
    xor ax, es:[di]
EX4:
    mov es:[di], ax
    retn
MEDIUM_LOAD endp

; ---------------------------------------------------------------------------

GRAPHICS_READ PROC NEAR
    mov ax, CURSOR_POSITION
    call  POSITION
    mov dx, es
    mov bx, 30h ; '0'
    mov es, bx
    xor si, si
    mov cx, 4
    mov bp, 2000h
    test  MODE_FLAG, 40h
    mov ds, dx
    mov di, ax
    jnz short GRR3
GRR1:
    xor bp, bp
    call  BYTE_TO_WORD
    call  BYTE_TO_WORD
    add di, 50h ; 'P'
    loop  GRR1
    jmp short GRR4
    db  90h
GRR3:
    mov al, [di]
    mov ah, ds:[bp+di]
    mov es:[si], ax
    call  ADD_OFFSET
    loop  GRR3
GRR4:
    mov bx, cs
    mov ds, bx
    mov di, OFFSET GRAPHICS_CHAR ;0A16h
    sub di, 8
    mov al, 0
    xor si, si
GRR40:
    add di, 8
GRR401:
    xor bx, bx
    mov ah, 8
GRR41:
    mov dl, es:[bx+si]
    cmp dl, [bx+di]
    jnz short GRR43
    inc bx
    dec ah
    jnz short GRR41
GRR42:
    jmp VIDEO_RETURN
GRR43:
    inc al
    cmp al, 0
    jz  short GRR42
    jg  short GRR40
    test  al, 7Fh
    jnz short GRR40
    mov ds, si
    lds di, EXTEN_PTR
    mov dx, ds
    or  dx, di
    jnz short GRR401
    xor al, al
    jmp short GRR42
GRAPHICS_READ ENDP

; ---------------------------------------------------------------------------
     ASSUME DS:DATA
BYTE_TO_WORD  proc near
    mov ax, ds:[bp+di]
    xchg  al, ah
    xor dl, dl
    mov bl, 1
MRB1:
    test  ax, 0FFFFh
    jz  short MRB4
    shr ax, 1
    jnb short MRB2
    or  dl, bl
MRB2:
    shr ax, 1
    jnb short MRB3
    or  dl, bl
MRB3:
    shl bl, 1
    jmp short MRB1
MRB4:
    mov es:[si], dl
    inc si
    mov bp, 2000h
    retn
BYTE_TO_WORD  endp

; ---------------------------------------------------------------------------
WRITE_ATCH_CUR PROC NEAR
    jcxz  short WC6
    mov ah, bl
    push  cx
    mov cx, 101h
    jmp short WRITE_CUR
WRITE_CH_CUR LABEL NEAR
    jcxz  short WC6
    push  cx
    mov cx, 1
WRITE_CUR:
    pop si
    test  MODE_FLAG, 70h
    jz  short WC0
    jmp GRAPHICS_WRITE
WC0:
    call  SEARCH_POSITION
    mov di, bx
    mov bl, al
    call  OUT_ADR
WC1:
    and ch, cl
    cli
    jz  short WC7
WC:
    in  al, dx
    and al, cl
    jnz short WC
WC2:
    in  al, dx
    and al, cl
    jz  short WC2
    mov al, bl
    stosw
    jmp short WC4
WC7:
    in  al, dx
    and al, cl
    jnz short WC7
WC8:
    in  al, dx
    and al, cl
    jz  short WC8
WC3:
    mov al, bl
    stosb
    add di, 1
WC4:
    sti
    dec si
    jg  short WC1
WC6:
    jmp VIDEO_RETURN
WRITE_ATCH_CUR ENDP

; ---------------------------------------------------------------------------
OUT_ADR   proc near
    mov dh, 3
    mov dl, CARD_6845_PORT
    add dl, 6
    retn
OUT_ADR   endp

; ---------------------------------------------------------------------------
POSITION  proc near
    push  cx
    mov cx, CRT_REGEN_START
    test  MODE_FLAG, 70h
    jz  short RP1
    shl ah, 1
    test  MODE_FLAG, 40h
    jz  short POS1
    shl ah, 1
    jmp short POS2
POS1:
    shl ah, 1
RP1:
    shl ax, 1
POS2:
    mov cl, al
    xchg  ah, al
    mul byte ptr CRT_COLUMN_COUNT
    add ax, cx
    pop cx
    retn
POSITION  endp

; ---------------------------------------------------------------------------
SEARCH_POSITION proc near
    push  ax
    call  GET_POSITION
    mov ax, [di]
    call  POSITION
    cmp bh, CURRENT_PAGE
    jnz short FP1
    xor bx, bx
    jmp short FP0
FP1:
    sub ax, CRT_REGEN_START
    call  REGEN_OFFSET
FP0:
    add bx, ax
    pop ax
    retn
SEARCH_POSITION endp

; ---------------------------------------------------------------------------
REGEN_OFFSET   proc near
    push  cx
    xor cx, cx
    cmp bh, 0
    jz  short REG_OF2
REG_OF1:
    add cx, PAGE_LEN
    dec bh
    jnz short REG_OF1
REG_OF2:
    mov bx, cx
    pop cx
    retn
REGEN_OFFSET   endp

; ---------------------------------------------------------------------------
WRITE_CLEAR_ROW proc near
    mov cl, dl
    push  bx
    push  bp
    mov bx, 2000h
    mov bp, di
    jb  short WCR1
WCR4:
    rep stosb
    jb  short WCR5
    mov di, bp
    add di, bx
    mov cl, dl
    stc
    jmp short WCR4
WCR1:
    push  si
    push  si
WCR3:
    rep movsb
    jnb short WCR2
    pop si
    mov di, bp
    add di, bx
    add si, bx
    mov cl, dl
    clc
    jmp short WCR3
WCR2:
    pop si
WCR5:
    mov di, bp
    pop bp
    pop bx
    add di, bp
    retn
WRITE_CLEAR_ROW endp

; ---------------------------------------------------------------------------
SELECT_VIDEO_MOD PROC NEAR
    mov di, OFFSET VIDEO_MOD+30 ;7DEh
    mov cx, 1Eh
XX44:
    dec di
    mov byte ptr [di], 0
    loop  XX44
    mov word ptr [di+17h], 107h
    mov dx, STATUS_OF_EQUP
    db  81h, 0E2h, 30h, 00h ;    and dx, 0030h ;???
    cmp dx, 30h ; '0'
    jnz short GGG
    mov CARD_6845_PORT, 0B4h ; ''
    mov VIDEO_EQUP, 0B0h ; ''
    jmp short VVV
    db  90h ; 
GGG:
    mov CARD_6845_PORT, 0D4h ; ''
    mov VIDEO_EQUP, 0B8h ; ''
VVV:
    mov dh, 3
ESS:
    mov dl, CARD_6845_PORT
    test  dl, 20h
    jz  short LX444
    mov ax, 107h
    jmp short LX30
LX444:
    xor ah, ah
    cmp al, 6
    jbe short LX30
    jmp VIDEO_RETURN
LX30:
    mov [di+1Ah], dx
    mov [di], al
    xchg  ah, al
    push  dx
    add dx, 4
    out dx, al
    mov ch, 1
    mov cl, ah
    shl ch, cl
    mov MODE_FLAG, ch
    mov dx, 40
    test  ch, 33h
    jnz short XX55
    add dl, 40
XX55:
    mov [di+1], dx
    xor bx, bx
    mov cx, 2000h
    mov si, 720h
    mov dx, 800h
    push  ax
    mov ax, 0B800h
    mov es, ax
    pop ax
    test  MODE_FLAG, 3
    jnz short XX66
    add bx, 10h
    shl dx, 1
    test  MODE_FLAG, 0Ch
    jnz short XX66
    add bx, 10h
    shl dx, 1
    shl dx, 1
    mov si, 0
    test  MODE_FLAG, 70h
    jnz short XX66
    add bx, 10h
    sub cx, 1800h
    mov si, 720h
    push  ax
    mov ax, 0B000h
    mov es, ax
    pop ax
XX66:
    mov [di+3], dx
    pop dx
    push  ds
    mov bp, 0
    push  bp
    pop ds
XX77:
    mov es:[bp+0], si
    add bp, 2
    loop  XX77
    push  cs
    pop ds
    mov bp, OFFSET TABLE_VALUE ;262h
    add bp, bx
    mov cx, 10h
    xor al, al
LX10:
    mov bl, ds:[bp+0]
    call  OUT_ONE
    inc bp
    inc al
    loop  LX10
     ASSUME DS:DATA
    pop ds
    xchg  ah, al
    xor ah, ah
    add dx, 4
    mov si, 2A2h
    add si, ax
    mov al, cs:[si]
    out dx, al
    mov [di+1Ch], al
    inc dx
    mov al, 1Fh
    test  MODE_FLAG, 40h
    jnz short XX11_2
    add al, 11h
XX11_2:
    out dx, al
    mov [di+1Dh], al
VIDEO_RETURN:
    call  RECOVER_REGISTER
    iret
SELECT_VIDEO_MOD ENDP

; ---------------------------------------------------------------------------
WRITE_TTY PROC NEAR
    mov bh, CURRENT_PAGE
    mov bp, ax
    call  GET_POSITION
    mov dx, [di]
    mov NATIVE_POS, dh
    mov cl, byte ptr CRT_COLUMN_COUNT
    mov ch, 18h
    mov si, cx
    mov ah, 0Ah
    cmp al, 0Dh
    jnz short L1
    xor dl, dl
    jmp short WR_TT3
L1:
    cmp al, 0Ah
    jnz short L3
L1111:
    cmp dh, ch
    jz  short SET_CRSR
    add dh, 1
    jmp short WR_TT3
L3:
    mov cx, 2
    cmp al, 8
    jnz short L4
    test  dl, 0FFh
    jz  short WR_TT1
    sub dl, 1
L8:
    call  POSI_CUR
    mov al, 20h ; ' '
    mov ah, 0Ah
    mov bl, 1
    mov bh, CURRENT_PAGE
    mov cx, 1
    int 23h
    jmp short WR_TT2
    db  90h
WR_TT1:
    cmp NATIVE_POS, 0
    jz  short WR_TT3
    dec dh
    mov dl, byte ptr CRT_COLUMN_COUNT
    dec dl
    jmp short L8
WR_TT3:
    call  POSI_CUR
WR_TT2:
    mov ax, bp
    jmp short VIDEO_RETURN
L4:
    cmp al, 7
    jnz short L6
    mov cx, 0
    mov bl, 3
    int 0Ch
    jmp short WR_TT2
L6:
    dec cx
    int 23h
    mov cx, si
    add dl, 1
    cmp dl, cl
    jl  short WR_TT3
    xor dl, dl
    jmp short L1111
SET_CRSR:
    call  POSI_CUR
    xor bh, bh
    test  MODE_FLAG, 8Fh
    jz  short SCROL_UP
    push  ds
    call  READ_ATCH_1
    pop ds
    mov bh, ah
SCROL_UP:
    sub si, 1
    mov ax, 601h
    mov dx, si
    xor cx, cx
    int 23h
    jmp short WR_TT2
WRITE_TTY ENDP

; ---------------------------------------------------------------------------
SCROLL_UP PROC NEAR
    stc
    push  ax
    mov ax, cx
    jmp short STOC
FNN1:
    popf
    pop ax
    jmp VIDEO_RETURN
SCROLL_DOWN LABEL NEAR
    std
    clc
    push  ax
    mov ax, dx
STOC:
    pushf
    sub dh, ch
    jb  short FNN1
    sub dl, cl
    jle short FNN1
    add dx, 101h
    call  POSITION
    push  ax
    pop di
    test  MODE_FLAG, 70h
    jz  short STOC1
    jmp GRAPHICS_UP_DOWN
STOC1:
    push  ax
    pop si
    popf
    pop ax
    mov bl, 20h ; ' '
    mov bp, bx
    push  ax
    pushf
    shl al, 1
    mov bx, CRT_COLUMN_COUNT
    mul bl
    shl bx, 1
    popf
    jb  short AU3
    neg ax
    neg bx
AU3:
    add si, ax
    call  CRT_TURN_OFF
    pop ax
    push  ds
    mov cx, es
    mov ds, cx
    sub ch, ch
    test  al, 0FFh
    jz  short CN
    sub dh, al
    xchg  al, dh
    jz  short CN
BN:
    stc
    call  JN
    add si, bx
    dec al
    jg  short BN
CN:
    mov ax, bp
DN1:
    clc
    call  JN
    dec dh
    jg  short DN1
    pop ds
    call  CRT_TURN_ON
    jmp VIDEO_RETURN
SCROLL_UP ENDP
; ---------------------------------------------------------------------------

JN PROC NEAR
    mov cl, dl
    push  di
    push  si
    jb  short AM
    rep stosw
    jmp short AC
AM:
    rep movsw
AC:
    pop si
    pop di
    add di,bx
    retn
JN ENDP
; ---------------------------------------------------------------------------
CRT_TURN_ON PROC NEAR
    test  byte ptr MODE_FLAG, 0Ch
    jz  short ON1
    mov al, byte ptr SET_MODE
    mov dx, CRT_CONTROL ;3D8h
    out dx, al
ON1:
    retn
CRT_TURN_ON ENDP
; ---------------------------------------------------------------------------

CRT_TURN_OFF PROC NEAR
    test  byte ptr MODE_FLAG, 0Ch
    jz  short OFF1
    push  dx
    mov dx, CRT_STATUS ;3DAh
HN1:
    in  al, dx
    and al, 8
    jnz short HN1
HN2:
    in  al, dx
    and al, 8
    jz  short HN2
    sub dl, 2
    mov al, 21h ; '!'
    out dx, al
    pop dx
OFF1:
    retn
CRT_TURN_OFF ENDP

; ---------------------------------------------------------------------------
ACT_DISP_PAGE PROC NEAR
    mov bh, al
    call  GET_POSITION
    mov byte ptr CURRENT_PAGE, bh
    call  REGEN_OFFSET
    mov word ptr CRT_REGEN_START, bx
    shr bx, 1
    mov al, 0Ch
    call  OUT_TWO
    mov ax, [di]
    call  SET_CURSOR
    jmp VIDEO_RETURN
ACT_DISP_PAGE ENDP

; ---------------------------------------------------------------------------
OUT_ONE   proc near
    push  ax
    out dx, al
    inc dx
    mov al, bl
    out dx, al
    dec dx
    pop ax
    retn
OUT_ONE   endp

; ---------------------------------------------------------------------------
DEFINE_CURSOR_TYPE PROC NEAR
    mov bx, cx
    mov word ptr CURSOR_TYPE, bx
    mov al, 0Ah
    call  OUT_TWO
    jmp VIDEO_RETURN
DEFINE_CURSOR_TYPE ENDP

; ---------------------------------------------------------------------------
SET_CURSOR  proc near
    call  POSITION
    mov bx, ax
    sar bx, 1
    mov al, 0Eh
OUT_TWO:
    push  dx
    mov dx, word ptr CRT_ADDR
    xchg  bh, bl
    call  OUT_ONE
    inc al
    xchg  bh, bl
    call  OUT_ONE
    pop dx
    retn
SET_CURSOR  endp

; ---------------------------------------------------------------------------
GET_CURSOR PROC NEAR
    call  GET_POSITION
    mov ax, [di]
    mov cx, word ptr CURSOR_TYPE
    mov di, sp
    mov ss:[di+0Ch], cx
    call  RECOVER_REGISTER
    mov dx, ax
    iret
GET_CURSOR ENDP

; ---------------------------------------------------------------------------
POSITION_CURRENT_CURSOR PROC NEAR
    call  POSI_CUR
    jmp VIDEO_RETURN
POSITION_CURRENT_CURSOR ENDP

; ---------------------------------------------------------------------------
POSI_CUR  proc near
    call  GET_POSITION
    mov [di], dx
    cmp byte ptr CURRENT_PAGE, bh
    jnz short POSI1
    mov ax, dx
    call  SET_CURSOR
POSI1:
    retn
POSI_CUR  endp

; ---------------------------------------------------------------------------
GET_POSITION  proc near
    push  bx
    xchg  bh, bl
    xor bh, bh
    shl bx, 1
    mov di, OFFSET CURSOR_POSITION ;7C7h
    add di, bx
    pop bx
    retn
GET_POSITION  endp

; ---------------------------------------------------------------------------
READ_ATCH_CUR PROC NEAR
    test  byte ptr MODE_FLAG, 70h
    jz  short RA0
    jmp GRAPHICS_READ
RA0:
    call  READ_ATCH_1
    jmp VIDEO_RETURN
READ_ATCH_CUR ENDP

; ---------------------------------------------------------------------------
READ_ATCH_1 proc near
    call  SEARCH_POSITION
    call  OUT_ADR
    mov cx, es
    mov ds, cx
    mov cl, 1
    cli
TS:
    in  al, dx
    and al, cl
    jnz short TS
TS1:
    in  al, dx
    and al, cl
    jz  short TS1
    mov ax, [bx]
    sti
    retn
READ_ATCH_1 endp

; ---------------------------------------------------------------------------
READ_DOT PROC NEAR
    stc
    jmp short DOT_COM
WRITE_DOT:
    clc
DOT_COM:
    pushf
    mov bp, ax
    mov al, dl
    shr al, 1
    mov ah, 50h ; 'P'
    mul ah
    mov di, ax
    ror dl, 1
    jnb short XR1
    add di, 2000h
XR1:
    mov dx, cx
    mov bx, 302h
    and cl, 7
    shr dx, 1
    shr dx, 1
    test  byte ptr MODE_FLAG, 40h
    jz  short YG1
    shr dx, 1
    sub bx, 201h
    jmp short YG2
YG1:
    and cl, 0F3h
YG2:
    add di, dx
    test  byte ptr MODE_FLAG, 40h
    jnz short XR2
    shl cl, 1
    inc cl
XR2:
    xor cl, 7
    shl bh, cl
    popf
    jnb short WRITE_DOT_1
    mov al, es:[di]
    and al, bh
    shr al, cl
    jmp VIDEO_RETURN
READ_DOT ENDP
; ---------------------------------------------------------------------------
WRITE_DOT_1:
    mov ax, bp
    shl al, cl
    and al, bh
    mov cl, al
    mov bl, es:[di]
    mov ax, bp
    test  al, 80h
    jz  short XR3
    xor cl, bl
    jmp short XR4
XR3:
    not bh
    and bl, bh
    or  cl, bl
XR4:
    mov es:[di], cl
    jmp VIDEO_RETURN

; ---------------------------------------------------------------------------
GET_LP_POSITION PROC NEAR
    mov dx, CRT_STATUS ;3DAh
    mov si, dx
    xor ah, ah
    in  al, dx
    and al, 6
    jnz short LZ747
    jmp LZ7
LZ747:
    cmp al, 2
    jz  short LZ0
    jmp LZ7
LZ0:
    mov cx, 1011h
    mov bl, 0D5h ; ''
    sub dx, 6
    mov al, ch
    out dx, al
    xchg  dl, bl
    in  al, dx
    mov bh, al
    xchg  dl, bl
    mov al, cl
    out dx, al
    xchg  dl, bl
    in  al, dx
    mov bl, al
    mov dx, CRT_REGEN_START
    add dx, 2
    test  byte ptr MODE_FLAG, 73h
    jnz short LZ1
    add dx, 2
LZ1:
    sub bx, dx
    jns short LZ2
    xor bx, bx
LZ2:
    mov cx, 2803h
    xchg  ax, bx
    test  byte ptr MODE_FLAG, 70h
    jz  short LZ4
    div ch
    mov ch, al
    add ch, ch
    mov dl, ah
    mov dh, al
    xchg  al, ah
    xor ah, ah
    shl ax, cl
    push  ax
    mov al, dh
    inc cl
    div cl
    mov dh, al
    pop ax
    test  byte ptr MODE_FLAG, 40h
    jz  short LZ3
    shl dl, 1
    shl ax, 1
LZ3:
    mov bx, ax
    jmp short LZ6
LZ4:
    test  byte ptr MODE_FLAG, 3
    jnz short LZ5
    shl ch, 1
LZ5:
    div ch
    mov dx, ax
    xchg  dh, dl
    xchg  ah, al
    xor ah, ah
    shl ax, cl
    mov bx, ax
    mov ch, dh
    shl ch, cl
LZ6:
    mov ah, 1
LZ7:
    xchg  si, dx
    inc dx
    out dx, al
    xchg  si, dx
    mov di, sp
    mov ss:[di+0Eh], bx
    mov ss:[di+0Ch], cx
    mov ss:[di+0Ah], dx
    call  RECOVER_REGISTER
    iret
GET_LP_POSITION ENDP

; ---------------------------------------------------------------------------
SET_COLOR PROC NEAR
    mov cl, PALLETTE
    call  OUT_ADR
    dec dx
    and bh, bh
    jz  short SC
    and cl, 1Fh
    and bl, 1
    jz  short SC1
    or  cl, 20h
    jmp short SC1
SC:
    and bl, 0DFh
    and cl, 20h
    or  cl, bl
SC1:
    mov al, cl
    out dx, al
    mov PALLETTE, cl
    jmp VIDEO_RETURN
SET_COLOR ENDP

; ---------------------------------------------------------------------------
VIDEO_STATE PROC NEAR
    call  RECOVER_REGISTER
    push  ds
    mov ax, 0
    mov ds, ax
    mov al, byte ptr VIDEO_MOD
    mov ah, byte ptr CRT_COLUMN_COUNT
    mov bh, byte ptr CURRENT_PAGE
    pop ds
    iret
VIDEO_STATE ENDP

; ---------------------------------------------------------------------------
CHANGE_DS proc near
    push  ax
    mov ax, 0
    mov ds, ax
    pop ax
    retn
CHANGE_DS endp

; ---------------------------------------------------------------------------
GRAPHICS_CHAR:
    db    0,    0,    0,    0,    0,    0,    0,    0 ;00
    db  7Eh,  81h, 0A5h,  81h, 0A5h, 0BDh,  81h,  7Eh
    db  7Eh, 0FFh, 0DBh, 0FFh, 0DBh, 0C3h, 0FFh,  7Eh
    db  36h,  7Fh,  7Fh,  7Fh,  3Eh,  1Ch,    8,    0
    db    8,  1Ch,  3Eh,  7Fh,  3Eh,  1Ch,    8,    0
    db  1Ch,  3Eh,  1Ch,  7Fh,  7Fh,  3Eh,  1Ch,  3Eh
    db    8,    8,  1Ch,  3Eh,  7Fh,  3Eh,  1Ch,  3Eh
    db    0,    0,  18h,  3Ch,  3Ch,  18h,    0,    0
    db 0FFh, 0FFh, 0E7h, 0C3h, 0C3h, 0E7h, 0FFh, 0FFh
    db    0,  3Ch,  66h,  42h,  42h,  66h,  3Ch,    0
    db 0FFh, 0C3h,  99h, 0BDh, 0BDh,  99h, 0C3h, 0FFh
    db  1Fh,    7,  0Fh,  79h, 0CCh, 0CCh, 0CCh,  78h
    db  3Ch,  66h,  66h,  66h,  3Ch,  18h,  7Eh,  18h
    db  1Ch,  1Eh,  19h,  1Bh,  3Ah,  70h, 0F0h, 0E0h
    db  7Fh,  63h,  7Fh,  63h, 0E3h, 0E7h, 0C7h,    6
    db  99h,  5Ah,  3Ch, 0E7h, 0E7h,  3Ch,  5Ah,  99h

    db  40h,  70h,  7Ch,  7Fh,  7Ch,  70h,  40h,    0 ;10
    db    1,    7,  1Fh,  7Fh,  1Fh,    7,    1,    0
    db  18h,  3Ch,  7Eh,  18h,  18h,  7Eh,  3Ch,  18h
    db  66h,  66h,  66h,  66h,  66h,    0,  66h,    0
    db  7Fh, 0DBh, 0DBh,  7Bh,  1Bh,  1Bh,  19h,    0
    db  1Eh,  31h,  1Ch,  36h,  36h,  1Ch,  46h,  3Ch
    db    0,    0,    0,  7Eh,  7Eh,  7Eh,    0,    0
    db  18h,  3Ch,  7Eh,  18h,  7Eh,  3Ch,  18h, 0FFh
    db  0Ch,  1Eh,  3Fh,  0Ch,  0Ch,  0Ch,  0Ch,    0
    db  0Ch,  0Ch,  0Ch,  0Ch,  3Fh,  1Eh,  0Ch,    0
    db    0,  0Ch,    6,  7Fh,    6,  0Ch,    0,    0
    db    0,  18h,  30h,  7Fh,  30h,  18h,    0,    0
    db    0,    0,  60h,  60h,  60h,  7Fh,    0,    0
    db    0,    0,  24h,  66h, 0FFh,  66h,  24h,    0
    db    0,    0,  18h,  3Ch,  7Fh, 0FFh, 0FFh,    0
    db    0,    0, 0FFh, 0FFh,  7Eh,  3Ch,  18h,    0

    db    0,    0,    0,    0,    0,    0,    0,    0 ;20
    db  18h,  3Ch,  3Ch,  18h,  18h,    0,  18h,    0
    db  36h,  36h,  36h,    0,    0,    0,    0,    0
    db  36h,  36h,  7Fh,  36h,  7Fh,  36h,  36h,    0
    db  0Ch,  3Fh,  68h,  3Eh,  0Bh,  7Eh,  18h,    8
    db  62h,  66h,  0Ch,  18h,  30h,  66h,  46h,    0
    db  1Ch,  36h,  1Ch,  18h,  3Dh,  66h,  3Dh,    0
    db  18h,  18h,  30h,    0,    0,    0,    0,    0
    db  0Ch,  18h,  30h,  30h,  30h,  18h,  0Ch,    0
    db  30h,  18h,  0Ch,  0Ch,  0Ch,  18h,  30h,    0
    db    0,  42h,  3Ch,  7Eh,  3Ch,  42h,    0,    0
    db    0,  18h,  18h,  7Eh,  18h,  18h,    0,    0
    db    0,    0,    0,    0,    0,  18h,  18h,  30h
    db    0,    0,    0,  7Eh,    0,    0,    0,    0
    db    0,    0,    0,    0,    0,  18h,  18h,    0
    db    3,    6,  0Ch,  18h,  30h,  60h,  40h,    0

    db  3Eh,  67h,  6Fh,  7Bh,  73h,  63h,  3Eh,    0 ;30
    db  0Ch,  1Ch,  0Ch,  0Ch,  0Ch,  0Ch,  3Fh,    0
    db  3Ch,  66h,    6,  1Ch,  30h,  66h,  7Eh,    0
    db  3Ch,  66h,    6,  1Ch,    6,  66h,  3Ch,    0
    db  0Eh,  1Eh,  36h,  66h,  7Fh,    6,    6,    0
    db  7Eh,  60h,  7Ch,    6,    6,  66h,  3Ch,    0
    db  3Ch,  66h,  60h,  7Ch,  66h,  66h,  3Ch,    0
    db  7Eh,  66h,    6,  0Ch,  18h,  18h,  18h,    0
    db  3Ch,  66h,  66h,  3Ch,  66h,  66h,  3Ch,    0
    db  3Ch,  66h,  66h,  3Eh,    6,  66h,  3Ch,    0
    db    0,  18h,  18h,    0,    0,  18h,  18h,    0
    db    0,  18h,  18h,    0,    0,  18h,  18h,  30h
    db  0Ch,  18h,  30h,  60h,  30h,  18h,  0Ch,    0
    db    0,    0,  7Eh,    0,  7Eh,    0,    0,    0
    db  30h,  18h,  0Ch,    6,  0Ch,  18h,  30h,    0
    db  3Ch,  66h,  66h,  0Ch,  18h,    0,  18h,    0

    db  3Eh,  63h,  6Fh,  6Bh,  6Fh,  60h,  3Eh,    0 ;40
    db  18h,  3Ch,  66h,  66h,  7Eh,  66h,  66h,    0
    db  7Eh,  33h,  33h,  3Eh,  33h,  33h,  7Eh,    0
    db  1Fh,  33h,  60h,  60h,  60h,  33h,  1Eh,    0
    db  7Ch,  36h,  33h,  33h,  33h,  36h,  7Ch,    0
    db  7Fh,  31h,  34h,  3Ch,  34h,  31h,  7Fh,    0
    db  7Fh,  31h,  34h,  3Ch,  34h,  30h,  78h,    0
    db  1Fh,  33h,  60h,  60h,  67h,  33h,  1Fh,    0
    db  66h,  66h,  66h,  7Eh,  66h,  66h,  66h,    0
    db  3Ch,  18h,  18h,  18h,  18h,  18h,  3Ch,    0
    db  0Fh,    6,    6,    6,  66h,  66h,  3Ch,    0
    db  7Bh,  33h,  36h,  3Ch,  36h,  33h,  7Bh,    0
    db  78h,  30h,  30h,  30h,  31h,  33h,  7Fh,    0
    db  63h,  77h,  7Fh,  7Fh,  6Bh,  63h,  63h,    0
    db  63h,  73h,  7Bh,  6Fh,  67h,  63h,  63h,    0
    db  3Eh,  63h,  63h,  63h,  63h,  63h,  3Eh,    0

    db  7Eh,  33h,  33h,  3Eh,  30h,  30h,  78h,    0 ;50
    db  3Ch,  66h,  66h,  66h,  66h,  3Ch,  0Fh,    0
    db  7Eh,  33h,  33h,  3Eh,  3Ch,  36h,  73h,    0
    db  3Ch,  66h,  60h,  3Ch,    6,  66h,  3Ch,    0
    db  7Eh,  5Ah,  18h,  18h,  18h,  18h,  3Ch,    0
    db  66h,  66h,  66h,  66h,  66h,  66h,  3Ch,    0
    db  66h,  66h,  66h,  66h,  66h,  3Ch,  18h,    0
    db  63h,  63h,  63h,  6Bh,  7Fh,  77h,  22h,    0
    db  63h,  63h,  36h,  1Ch,  36h,  63h,  63h,    0
    db  66h,  66h,  66h,  3Ch,  18h,  18h,  3Ch,    0
    db  7Fh,  63h,  46h,  0Ch,  19h,  33h,  7Fh,    0
    db  3Ch,  30h,  30h,  30h,  30h,  30h,  3Ch,    0
    db  60h,  30h,  18h,  0Ch,    6,    3,    1,    0
    db  3Ch,  0Ch,  0Ch,  0Ch,  0Ch,  0Ch,  3Ch,    0
    db    8,  1Ch,  36h,  63h,    0,    0,    0,    0
    db    0,    0,    0,    0,    0,    0,    0, 0FFh

    db  18h,  18h,  0Ch,    0,    0,    0,    0,    0 ;60
    db    0,    0,  3Ch,    6,  3Eh,  26h,  3Bh,    0
    db  70h,  30h,  30h,  3Eh,  33h,  33h,  3Eh,    0
    db    0,    0,  3Ch,  66h,  60h,  62h,  3Ch,    0
    db  0Eh,    6,    6,  3Eh,  66h,  66h,  3Eh,    0
    db    0,    0,  3Ch,  66h,  7Eh,  60h,  3Ch,    0
    db  1Ch,  36h,  30h,  78h,  30h,  30h,  78h,    0
    db    0,    0,  3Eh,  66h,  66h,  3Eh,    6,  7Ch
    db  70h,  30h,  36h,  3Fh,  33h,  33h,  73h,    0
    db  18h,    0,  38h,  18h,  18h,  18h,  3Ch,    0
    db    6,    0,    6,    6,    6,  66h,  66h,  3Ch
    db  70h,  30h,  33h,  36h,  3Ch,  36h,  73h,    0
    db  38h,  18h,  18h,  18h,  18h,  18h,  3Ch,    0
    db    0,    0,  66h,  7Fh,  6Bh,  6Bh,  63h,    0
    db    0,    0,  7Ch,  7Eh,  66h,  66h,  66h,    0
    db    0,    0,  3Ch,  66h,  66h,  66h,  3Ch,    0

    db    0,    0,  7Eh,  33h,  33h,  3Eh,  30h,  78h ;70
    db    0,    0,  3Eh,  66h,  66h,  3Eh,    6,  0Fh
    db    0,    0,  6Fh,  3Bh,  30h,  30h,  78h,    0
    db    0,    0,  3Eh,  60h,  3Ch,    6,  7Ch,    0
    db  18h,  18h,  7Eh,  18h,  18h,  1Bh,  0Eh,    0
    db    0,    0,  66h,  66h,  66h,  66h,  3Bh,    0
    db    0,    0,  66h,  66h,  66h,  3Ch,  18h,    0
    db    0,    0,  63h,  63h,  6Bh,  7Fh,  36h,    0
    db    0,    0,  63h,  36h,  1Ch,  36h,  63h,    0
    db    0,    0, 0E6h,  66h,  66h,  3Eh,    6,  7Ch
    db    0,    0,  7Eh,  4Ch,  18h,  32h,  7Eh,    0
    db  0Eh,  18h,  18h,  70h,  18h,  18h,  0Eh,    0
    db  18h,  18h,  18h,    0,  18h,  18h,  18h,    0
    db  70h,  18h,  18h,  0Eh,  18h,  18h,  70h,    0
    db  31h,  49h,  46h,    0,    0,    0,    0,    0
    db    0,    8,  1Ch,  36h,  63h,  63h,  7Fh,    0

    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db    0
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
    db 0FFh
;    db 0FFh

INIT    endp
CODE    ends


    end
